public inbox for passt-dev@passt.top
 help / color / mirror / code / Atom feed
From: David Gibson <david@gibson.dropbear.id.au>
To: passt-dev@passt.top
Subject: [PATCH v2 26/32] test: Move context temporary files to state dir
Date: Thu, 08 Sep 2022 16:16:15 +1000	[thread overview]
Message-ID: <20220908061621.2430844-27-david@gibson.dropbear.id.au> (raw)
In-Reply-To: <20220908061621.2430844-1-david@gibson.dropbear.id.au>

[-- Attachment #1: Type: text/plain, Size: 5045 bytes --]

Currently the context command dispatch subsystem creates a bunch of
temporary files in $LOGDIR, which is messy.  Store them in $STATEDIR which
is for precisely this purpose.  The logs from each context still go into
$LOGDIR.

Signed-off-by: David Gibson <david(a)gibson.dropbear.id.au>
---
 test/lib/context | 61 +++++++++++++++++++++++++-----------------------
 1 file changed, 32 insertions(+), 29 deletions(-)

diff --git a/test/lib/context b/test/lib/context
index ccb0004..5448e20 100644
--- a/test/lib/context
+++ b/test/lib/context
@@ -17,17 +17,17 @@
 # $1:	Context name
 context_setup_common() {
 	__name="$1"
-	__prefix="${LOGDIR}/context_${__name}"
-	echo -n "${__name}$ " > "${__prefix}.log"
+	__log="${LOGDIR}/context_${__name}.log"
+	echo -n "${__name}$ " > "${__log}"
 }
 
 # context_setup_host() - Create a new context for running commands on the host
 # $1:	Context name
 context_setup_host() {
 	__name="$1"
-	__prefix="${LOGDIR}/context_${__name}"
+	__enter="${STATESETUP}/context_${__name}.enter"
 	context_setup_common "${__name}"
-	echo sh -c > "${__prefix}.enter"
+	echo sh -c > "${__enter}"
 }
 
 # context_setup_nsenter() - Create a new context for running commands in a namespace
@@ -36,9 +36,9 @@ context_setup_host() {
 context_setup_nsenter() {
 	__name="$1"
 	shift
-	__prefix="${LOGDIR}/context_${__name}"
+	__enter="${STATESETUP}/context_${__name}.enter"
 	context_setup_common "${__name}"
-	echo "nsenter $@ sh -c" > "${__prefix}.enter"
+	echo "nsenter $@ sh -c" > "${__enter}"
 }
 
 # context_setup_guest() - Create a new context for running commands in a guest
@@ -47,22 +47,23 @@ context_setup_nsenter() {
 context_setup_guest() {
 	__name="$1"
 	__cid="$2"
-	__prefix="${LOGDIR}/context_${__name}"
+	__enter="${STATESETUP}/context_${__name}.enter"
+	__ssh="${STATESETUP}/context_${__name}.ssh"
 	context_setup_common "${__name}"
 
-	cat > "${__prefix}.ssh" <<EOF
+	cat > "${__ssh}" <<EOF
 Host ${__name}
 	User root
-	UserKnownHostsFile ${__prefix}.hosts
+	UserKnownHostsFile ${STATESETUP}/context_{__name}.hosts
 	StrictHostKeyChecking no
 	IdentityFile ${BASEPATH}/guest-key
 	IdentityAgent none
 	ProxyCommand socat - VSOCK-CONNECT:${__cid}:22
 EOF
-	echo "ssh -F ${__prefix}.ssh ${__name}" > "${__prefix}.enter"
+	echo "ssh -F ${__ssh} ${__name}" > "${__enter}"
 
 	# Wait for the guest to be booted and accepting connections
-	while ! ssh -F "${__prefix}.ssh" "${__name}" :; do
+	while ! ssh -F "${__ssh}" "${__name}" :; do
 		sleep 0.1
 	done
 }
@@ -71,7 +72,7 @@ EOF
 # $1:	Context name
 context_teardown() {
 	__name="$1"
-	__prefix="${LOGDIR}/context_${__name}"
+	__prefix="${STATESETUP}/context_${__name}"
 	rm -f "${__prefix}.enter" "${__prefix}.ssh" "${__prefix}.hosts"
 }
 
@@ -79,8 +80,8 @@ context_teardown() {
 # $1:	Context name
 context_exists() {
 	__name="$1"
-	__prefix="${LOGDIR}/context_${__name}"
-	[ -f "${__prefix}.enter" ]
+	__enter="${STATESETUP}/context_${__name}.enter"
+	[ -f "${__enter}" ]
 }
 
 # context_run() - Run a shell command in a context, and wait for it to finish
@@ -88,18 +89,20 @@ context_exists() {
 # $*:	Command to start
 context_run() {
 	__name="$1"
-	__prefix="${LOGDIR}/context_${__name}"
-	__enter="$(cat "${__prefix}.enter")"
+	__log="${LOGDIR}/context_${__name}.log"
+	__enter="${STATESETUP}/context_${__name}.enter"
+	__stdout="${STATESETUP}/context_${__name}.stdout"
+	__stderr="${STATESETUP}/context_${__name}.stderr"
 	shift
-	echo "$*" >> "${__prefix}.log"
-	mkfifo "${__prefix}.stdout" "${__prefix}.stderr"
-	tee -a "${__prefix}.log" < "${__prefix}.stdout" &
-	tee -a "${__prefix}.log" < "${__prefix}.stderr" >&2 &
-	${__enter} "$*" >> "${__prefix}.stdout" 2>> "${__prefix}.stderr"
+	echo "$*" >> "${__log}"
+	mkfifo "${__stdout}" "${__stderr}"
+	tee -a "${__log}" < "${__stdout}" &
+	tee -a "${__log}" < "${__stderr}" >&2 &
+	$(cat ${__enter}) "$*" >> "${__stdout}" 2>> "${__stderr}"
 	rc=$?
-	rm "${__prefix}.stdout" "${__prefix}.stderr"
-	[ ${DEBUG} -eq 1 ] && echo "[Exit code: $rc]" >> "${__prefix}.log"
-	echo -n "${__name}$ " >> "${__prefix}.log"
+	rm "${__stdout}" "${__stderr}"
+	[ ${DEBUG} -eq 1 ] && echo "[Exit code: $rc]" >> "${__log}"
+	echo -n "${__name}$ " >> "${__log}"
 	return $rc
 }
 
@@ -108,9 +111,9 @@ context_run() {
 # $*:	Command to start
 context_run_bg() {
 	__name="$1"
-	__prefix="${LOGDIR}/context_${__name}"
+	__pidfile="${STATESETUP}/context_${__name}.pid"
 	context_run "$@" &
-	echo $! > "${__prefix}.pid"
+	echo $! > "${__pidfile}"
 }
 
 # context_wait() - Wait for background command in a context to complete
@@ -118,8 +121,8 @@ context_run_bg() {
 # Returns the status of the completed command
 context_wait() {
 	__name="$1"
-	__prefix="${LOGDIR}/context_${__name}"
-	__pid=$(cat "${__prefix}.pid")
-	rm "${__prefix}.pid"
+	__pidfile="${STATESETUP}/context_${__name}.pid"
+	__pid=$(cat "${__pidfile}")
+	rm "${__pidfile}"
 	wait ${__pid}
 }
-- 
@@ -17,17 +17,17 @@
 # $1:	Context name
 context_setup_common() {
 	__name="$1"
-	__prefix="${LOGDIR}/context_${__name}"
-	echo -n "${__name}$ " > "${__prefix}.log"
+	__log="${LOGDIR}/context_${__name}.log"
+	echo -n "${__name}$ " > "${__log}"
 }
 
 # context_setup_host() - Create a new context for running commands on the host
 # $1:	Context name
 context_setup_host() {
 	__name="$1"
-	__prefix="${LOGDIR}/context_${__name}"
+	__enter="${STATESETUP}/context_${__name}.enter"
 	context_setup_common "${__name}"
-	echo sh -c > "${__prefix}.enter"
+	echo sh -c > "${__enter}"
 }
 
 # context_setup_nsenter() - Create a new context for running commands in a namespace
@@ -36,9 +36,9 @@ context_setup_host() {
 context_setup_nsenter() {
 	__name="$1"
 	shift
-	__prefix="${LOGDIR}/context_${__name}"
+	__enter="${STATESETUP}/context_${__name}.enter"
 	context_setup_common "${__name}"
-	echo "nsenter $@ sh -c" > "${__prefix}.enter"
+	echo "nsenter $@ sh -c" > "${__enter}"
 }
 
 # context_setup_guest() - Create a new context for running commands in a guest
@@ -47,22 +47,23 @@ context_setup_nsenter() {
 context_setup_guest() {
 	__name="$1"
 	__cid="$2"
-	__prefix="${LOGDIR}/context_${__name}"
+	__enter="${STATESETUP}/context_${__name}.enter"
+	__ssh="${STATESETUP}/context_${__name}.ssh"
 	context_setup_common "${__name}"
 
-	cat > "${__prefix}.ssh" <<EOF
+	cat > "${__ssh}" <<EOF
 Host ${__name}
 	User root
-	UserKnownHostsFile ${__prefix}.hosts
+	UserKnownHostsFile ${STATESETUP}/context_{__name}.hosts
 	StrictHostKeyChecking no
 	IdentityFile ${BASEPATH}/guest-key
 	IdentityAgent none
 	ProxyCommand socat - VSOCK-CONNECT:${__cid}:22
 EOF
-	echo "ssh -F ${__prefix}.ssh ${__name}" > "${__prefix}.enter"
+	echo "ssh -F ${__ssh} ${__name}" > "${__enter}"
 
 	# Wait for the guest to be booted and accepting connections
-	while ! ssh -F "${__prefix}.ssh" "${__name}" :; do
+	while ! ssh -F "${__ssh}" "${__name}" :; do
 		sleep 0.1
 	done
 }
@@ -71,7 +72,7 @@ EOF
 # $1:	Context name
 context_teardown() {
 	__name="$1"
-	__prefix="${LOGDIR}/context_${__name}"
+	__prefix="${STATESETUP}/context_${__name}"
 	rm -f "${__prefix}.enter" "${__prefix}.ssh" "${__prefix}.hosts"
 }
 
@@ -79,8 +80,8 @@ context_teardown() {
 # $1:	Context name
 context_exists() {
 	__name="$1"
-	__prefix="${LOGDIR}/context_${__name}"
-	[ -f "${__prefix}.enter" ]
+	__enter="${STATESETUP}/context_${__name}.enter"
+	[ -f "${__enter}" ]
 }
 
 # context_run() - Run a shell command in a context, and wait for it to finish
@@ -88,18 +89,20 @@ context_exists() {
 # $*:	Command to start
 context_run() {
 	__name="$1"
-	__prefix="${LOGDIR}/context_${__name}"
-	__enter="$(cat "${__prefix}.enter")"
+	__log="${LOGDIR}/context_${__name}.log"
+	__enter="${STATESETUP}/context_${__name}.enter"
+	__stdout="${STATESETUP}/context_${__name}.stdout"
+	__stderr="${STATESETUP}/context_${__name}.stderr"
 	shift
-	echo "$*" >> "${__prefix}.log"
-	mkfifo "${__prefix}.stdout" "${__prefix}.stderr"
-	tee -a "${__prefix}.log" < "${__prefix}.stdout" &
-	tee -a "${__prefix}.log" < "${__prefix}.stderr" >&2 &
-	${__enter} "$*" >> "${__prefix}.stdout" 2>> "${__prefix}.stderr"
+	echo "$*" >> "${__log}"
+	mkfifo "${__stdout}" "${__stderr}"
+	tee -a "${__log}" < "${__stdout}" &
+	tee -a "${__log}" < "${__stderr}" >&2 &
+	$(cat ${__enter}) "$*" >> "${__stdout}" 2>> "${__stderr}"
 	rc=$?
-	rm "${__prefix}.stdout" "${__prefix}.stderr"
-	[ ${DEBUG} -eq 1 ] && echo "[Exit code: $rc]" >> "${__prefix}.log"
-	echo -n "${__name}$ " >> "${__prefix}.log"
+	rm "${__stdout}" "${__stderr}"
+	[ ${DEBUG} -eq 1 ] && echo "[Exit code: $rc]" >> "${__log}"
+	echo -n "${__name}$ " >> "${__log}"
 	return $rc
 }
 
@@ -108,9 +111,9 @@ context_run() {
 # $*:	Command to start
 context_run_bg() {
 	__name="$1"
-	__prefix="${LOGDIR}/context_${__name}"
+	__pidfile="${STATESETUP}/context_${__name}.pid"
 	context_run "$@" &
-	echo $! > "${__prefix}.pid"
+	echo $! > "${__pidfile}"
 }
 
 # context_wait() - Wait for background command in a context to complete
@@ -118,8 +121,8 @@ context_run_bg() {
 # Returns the status of the completed command
 context_wait() {
 	__name="$1"
-	__prefix="${LOGDIR}/context_${__name}"
-	__pid=$(cat "${__prefix}.pid")
-	rm "${__prefix}.pid"
+	__pidfile="${STATESETUP}/context_${__name}.pid"
+	__pid=$(cat "${__pidfile}")
+	rm "${__pidfile}"
 	wait ${__pid}
 }
-- 
2.37.3


  parent reply	other threads:[~2022-09-08  6:16 UTC|newest]

Thread overview: 33+ messages / expand[flat|nested]  mbox.gz  Atom feed  top
2022-09-08  6:15 [PATCH v2 00/32] Improve handling of test temporary files David Gibson
2022-09-08  6:15 ` [PATCH v2 01/32] test: Correctly match "background" with "wait" commands David Gibson
2022-09-08  6:15 ` [PATCH v2 02/32] test: Context execution helpers David Gibson
2022-09-08  6:15 ` [PATCH v2 03/32] test: Allow a tmux pane to watch commands executed in contexts David Gibson
2022-09-08  6:15 ` [PATCH v2 04/32] test: Integration of old-style pane execution and new context execution David Gibson
2022-09-08  6:15 ` [PATCH v2 05/32] test: Issue host commands via context for most tests David Gibson
2022-09-08  6:15 ` [PATCH v2 06/32] test: Use new-style contexts for passt pane in the pasta and passt tests David Gibson
2022-09-08  6:15 ` [PATCH v2 07/32] test: Add nsholder utility David Gibson
2022-09-08  6:15 ` [PATCH v2 08/32] test: Extend context system to run commands in namespace for pasta tests David Gibson
2022-09-08  6:15 ` [PATCH v2 09/32] test: Use context system for guest commands David Gibson
2022-09-08  6:15 ` [PATCH v2 10/32] test: Use context system for two_guests tests David Gibson
2022-09-08  6:16 ` [PATCH v2 11/32] test: Use new-style command issue for passt_in_ns tests David Gibson
2022-09-08  6:16 ` [PATCH v2 12/32] Don't store UID & GID persistently in the context structure David Gibson
2022-09-08  6:16 ` [PATCH v2 13/32] Split checking for root from dropping root privilege David Gibson
2022-09-08  6:16 ` [PATCH v2 14/32] Consolidate determination of UID/GID to run as David Gibson
2022-09-08  6:16 ` [PATCH v2 15/32] Safer handling if we can't open /proc/self/uid_map David Gibson
2022-09-08  6:16 ` [PATCH v2 16/32] Move self-isolation code into a separate file David Gibson
2022-09-08  6:16 ` [PATCH v2 17/32] Consolidate validation of pasta namespace options David Gibson
2022-09-08  6:16 ` [PATCH v2 18/32] Clean up and rename conf_ns_open() David Gibson
2022-09-08  6:16 ` [PATCH v2 19/32] Correctly handle --netns-only in pasta_start_ns() David Gibson
2022-09-08  6:16 ` [PATCH v2 20/32] Handle userns isolation and dropping root at the same time David Gibson
2022-09-08  6:16 ` [PATCH v2 21/32] Allow --userns when pasta spawns a command David Gibson
2022-09-08  6:16 ` [PATCH v2 22/32] test: Group tests by context then protocol, rather than the reverse David Gibson
2022-09-08  6:16 ` [PATCH v2 23/32] test: Remove unused variable FFMPEG_PID_FILE David Gibson
2022-09-08  6:16 ` [PATCH v2 24/32] test: Actually run cleanup function David Gibson
2022-09-08  6:16 ` [PATCH v2 25/32] test: Create common state directories for temporary files David Gibson
2022-09-08  6:16 ` David Gibson [this message]
2022-09-08  6:16 ` [PATCH v2 27/32] test: Dont regnerate small test file in pasta/tcp David Gibson
2022-09-08  6:16 ` [PATCH v2 28/32] test: Use paths in __STATEDIR__ instead of 'temp' and 'tempdir' directives David Gibson
2022-09-08  6:16 ` [PATCH v2 29/32] test: Move pause temporary file to state directory David Gibson
2022-09-08  6:16 ` [PATCH v2 30/32] test: Store pcap files in $LOGDIR instead of /tmp David Gibson
2022-09-08  6:16 ` [PATCH v2 31/32] test: Move pidfiles and nsholder sockets into state directory David Gibson
2022-09-08  6:16 ` [PATCH v2 32/32] test: Move video processing files to $STATEBASE David Gibson

Reply instructions:

You may reply publicly to this message via plain-text email
using any one of the following methods:

* Save the following mbox file, import it into your mail client,
  and reply-to-all from there: mbox

  Avoid top-posting and favor interleaved quoting:
  https://en.wikipedia.org/wiki/Posting_style#Interleaved_style

* Reply using the --to, --cc, and --in-reply-to
  switches of git-send-email(1):

  git send-email \
    --in-reply-to=20220908061621.2430844-27-david@gibson.dropbear.id.au \
    --to=david@gibson.dropbear.id.au \
    --cc=passt-dev@passt.top \
    /path/to/YOUR_REPLY

  https://kernel.org/pub/software/scm/git/docs/git-send-email.html

* If your mail client supports setting the In-Reply-To header
  via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line before the message body.
Code repositories for project(s) associated with this public inbox

	https://passt.top/passt

This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox;
as well as URLs for IMAP folder(s).